import importlib
import FreeCAD as App
import FreeCADGui as Gui
import os
import sys

from .. import settings
from ..project import Project

from .Syncable import Syncable

class SyncFrom(Syncable):
    method = 'sync_from'

    def GetResources(self):
        tooltip  = '<p>Reload Board from KiCAD.</p>'
        iconFile = os.path.join(settings.ICONPATH, 'import_brd_file.svg')

        return {
            'MenuText': 'Sync from KiCAD',
            'ToolTip': tooltip,
            'Pixmap' : iconFile
        }

Gui.addCommand('kiconn_sync_from', SyncFrom())
